﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using System.IO;
using Microsoft.WindowsCE.Forms;
using Opticon.Bcrctl;
using Opticon.Sysctl;

namespace BCRCTL_Sample
{
    public partial class Form1 : Form
    {
        Opticon.Bcrctl.BarcodeReader BCR;
        Opticon.Bcrctl.BarcodeDecoder BCD;
        Opticon.Sysctl.Keyboard KBD;

        public Form1()
        {
            InitializeComponent();

            BCR = new BarcodeReader();
            BCD = new BarcodeDecoder();
            KBD = new Keyboard();

            BCD.DataHandler += new Opticon.Bcrctl.BarcodeDecoder.ScanEventHandler(decoder_DataHandler);
        }

        private void Form1_Load(object sender, EventArgs e)
        {
            // Initialize
            BCR.PowerOn = true;
            BCR.TriggerKeyEnabled = false;
            BCR.OutputMode = DataOutput.BUFFER;
            BCD.SuffixChar = 0;
            KBD.FunctionKeyEnable = false;

            WindowState = FormWindowState.Maximized;
            textBox_BarcodeData.Focus();
        }

        private void Form1_Closed(object sender, EventArgs e)
        {
            // Recovery
            BCR.TriggerKeyEnabled = true;
            BCR.OutputMode = DataOutput.CLIPBOARD;
            BCD.SuffixChar = 13;
            KBD.FunctionKeyEnable = true;

            BCD.DataHandler -= new Opticon.Bcrctl.BarcodeDecoder.ScanEventHandler(decoder_DataHandler);
        }

        void decoder_DataHandler(object sender, ScanEventArgs e)
        {
            if (e.ReadStatus == LastReadStatusList.GOOD)
                // Show result
                textBox_BarcodeData.Text = Encoding.Default.GetString(e.BarcodeData, 0, (int)e.DataLength);
            else
                // Show error-message
                textBox_BarcodeData.Text = e.ReadStatus.ToString();
        }

        private void textBox_BarcodeData_KeyDown(object sender, KeyEventArgs e)
        {
            switch (Convert.ToUInt16(e.KeyCode))
            {
                case 0xE3:  // Q1 key
                    BCR.TriggerPress();
                    System.Threading.Thread.Sleep(100);
                    BCR.TriggerRelease();
                    break;

                case 0xE4:  // Q2 key
                    BCD.AbortScan();
                    textBox_BarcodeData.Text = "";
                    break;
            }
        }


    }
}